/*********************************************************************
*                                                                    *
*                SEGGER Microcontroller GmbH & Co. KG                *
*        Solutions for real time microcontroller applications        *
*                                                                    *
**********************************************************************
*                                                                    *
* C-file generated by:                                               *
*                                                                    *
*        GUI_Builder for emWin version 5.32                          *
*        Compiled Oct  8 2015, 11:59:02                              *
*        (c) 2015 Segger Microcontroller GmbH & Co. KG               *
*                                                                    *
**********************************************************************
*                                                                    *
*        Internet: www.segger.com  Support: support@segger.com       *
*                                                                    *
**********************************************************************
*/

// USER START (Optionally insert additional includes)
#include "string.h"
// USER END

#include "DIALOG.h"

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
#define ID_WINDOW_0 (GUI_ID_USER + 0x00)
#define ID_CHECKBOX_0 (GUI_ID_USER + 0x01)
#define ID_CHECKBOX_1 (GUI_ID_USER + 0x02)


// USER START (Optionally insert additional defines)
// USER END

/*********************************************************************
*
*       Static data
*
**********************************************************************
*/

// USER START (Optionally insert additional static data)
// USER END

/*********************************************************************
*
*       _aDialogCreate
*/
static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = {
  { WINDOW_CreateIndirect, "WindowChckBx", ID_WINDOW_0, 0, 0, 320, 240, 0, 0x0, 0 },
  { CHECKBOX_CreateIndirect, "Checkbox1", ID_CHECKBOX_0, 60, 65, 85, 20, 0, 0x0, 0 },
  { CHECKBOX_CreateIndirect, "Checkbox2", ID_CHECKBOX_1, 60, 120, 85, 20, 0, 0x0, 0 },
  // USER START (Optionally insert additional widgets)
  // USER END
};

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/

// USER START (Optionally insert additional static code)
static int _DrawSkinFlex_CHECKBOX(const WIDGET_ITEM_DRAW_INFO * pDrawItemInfo) {
    CHECKBOX_SKINFLEX_PROPS Props, Props_def;   // For skin colors;

    switch (pDrawItemInfo->Cmd) {
    case WIDGET_ITEM_DRAW_BUTTON:   // In case of drawing checkbox button area
        if (WM_HasFocus(pDrawItemInfo->hWin)) // If the checkbox got the focus
        {
            // Get the default checkbox skin colors
            CHECKBOX_GetSkinFlexProps(&Props_def, CHECKBOX_SKINFLEX_PI_ENABLED);

            // Copy the default colors for changing it
            memcpy(&Props, &Props_def, sizeof(Props_def));

            // Change colors (see chapter 22.9 "CHECKBOX SKIN FLEX")
            Props.aColorFrame[0] = GUI_RED;         // Change outer frame color 
            Props.aColorFrame[1] = GUI_YELLOW;      // Change middle frame color
            Props.aColorFrame[2] = GUI_LIGHTRED;    // Change inner fame color
            Props.aColorInner[0] = GUI_YELLOW;      // Change upper gradient color  
            Props.aColorInner[1] = GUI_DARKYELLOW;  // Change lower gradient color  

            // Set the new skin colors
            CHECKBOX_SetSkinFlexProps(&Props, CHECKBOX_SKINFLEX_PI_ENABLED);

            // Draw the checkbox with the new colors 
            CHECKBOX_DrawSkinFlex(pDrawItemInfo);

            // Return default skin for the other checkboxes 
            CHECKBOX_SetSkinFlexProps(&Props_def, CHECKBOX_SKINFLEX_PI_ENABLED);
        }
        else
            CHECKBOX_DrawSkinFlex(pDrawItemInfo);   // If the checkbox hasn't the focus call the standard skin drawing
        break;
    default:
        return CHECKBOX_DrawSkinFlex(pDrawItemInfo); // Call the standard skin drawing in other cases (drawing checkmark etc...)
        break;
    }

    return 0;
}
// USER END

/*********************************************************************
*
*       _cbDialog
*/
static void _cbDialog(WM_MESSAGE * pMsg) {
  WM_HWIN hItem;
  int     NCode;
  int     Id;
  // USER START (Optionally insert additional variables)
  // USER END

  switch (pMsg->MsgId) {
  case WM_INIT_DIALOG:
    //
    // Initialization of 'WindowChckBx'
    //
    hItem = pMsg->hWin;
    WINDOW_SetBkColor(hItem, GUI_MAKE_COLOR(0x00E9DFCD));
    //
    // Initialization of 'Checkbox1'
    //
    hItem = WM_GetDialogItem(pMsg->hWin, ID_CHECKBOX_0);
    CHECKBOX_SetText(hItem, "Checkbox 1");
    //
    // Initialization of 'Checkbox2'
    //
    hItem = WM_GetDialogItem(pMsg->hWin, ID_CHECKBOX_1);
    CHECKBOX_SetText(hItem, "Checkbox 2");
    // USER START (Optionally insert additional code for further widget initialization)
    hItem = WM_GetDialogItem(pMsg->hWin, ID_CHECKBOX_1);    // Get the handler of the Checkbox 2
    CHECKBOX_SetSkin(hItem, _DrawSkinFlex_CHECKBOX);  // Set the skin colors change function on this checkbox
    // USER END
    break;
  case WM_NOTIFY_PARENT:
    Id    = WM_GetId(pMsg->hWinSrc);
    NCode = pMsg->Data.v;
    switch(Id) {
    case ID_CHECKBOX_0: // Notifications sent by 'Checkbox1'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_VALUE_CHANGED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    case ID_CHECKBOX_1: // Notifications sent by 'Checkbox2'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_VALUE_CHANGED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    // USER START (Optionally insert additional code for further Ids)
    // USER END
    }
    break;
  // USER START (Optionally insert additional message handling)
  // USER END
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       CreateWindowChckBx
*/
WM_HWIN CreateWindowChckBx(void);
WM_HWIN CreateWindowChckBx(void) {
  WM_HWIN hWin;

  hWin = GUI_CreateDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), _cbDialog, WM_HBKWIN, 0, 0);
  return hWin;
}

// USER START (Optionally insert additional public code)
// USER END

/*************************** End of file ****************************/
